net.sourceforge.pmd.lang.java.rule.strings

## Class AvoidDuplicateLiteralsRule

- java.lang.Object
- - net.sourceforge.pmd.AbstractPropertySource
  - - net.sourceforge.pmd.lang.rule.AbstractRule
    - - net.sourceforge.pmd.lang.java.rule.AbstractJavaRule
      - - net.sourceforge.pmd.lang.java.rule.strings.AvoidDuplicateLiteralsRule

All Implemented Interfaces:
  JavaParserVisitor, ImmutableLanguage, PropertySource, Rule

    public class AvoidDuplicateLiteralsRule
    extends AbstractJavaRule

### Nested Class Summary

Nested Classes
`static class` `AvoidDuplicateLiteralsRule.ExceptionParser`

### Field Summary

Fields
`static FileProperty` `EXCEPTION_FILE_DESCRIPTOR`
`static StringProperty` `EXCEPTION_LIST_DESCRIPTOR`
`static IntegerProperty` `MINIMUM_LENGTH_DESCRIPTOR`
`static CharacterProperty` `SEPARATOR_DESCRIPTOR`
`static BooleanProperty` `SKIP_ANNOTATIONS_DESCRIPTOR`
`static IntegerProperty` `THRESHOLD_DESCRIPTOR`

### Fields inherited from class net.sourceforge.pmd.AbstractPropertySource

`propertyDescriptors, propertyValuesByDescriptor`

### Fields inherited from interface net.sourceforge.pmd.Rule

`VIOLATION_SUPPRESS_REGEX_DESCRIPTOR, VIOLATION_SUPPRESS_XPATH_DESCRIPTOR`

### Constructor Summary

Constructors
Constructor and Description
`AvoidDuplicateLiteralsRule()`

### Method Summary

Methods
`String` `dysfunctionReason()` Returns a description of why the receiver may be dysfunctional.
`Object` `visit(ASTCompilationUnit node, Object data)`
`Object` `visit(ASTLiteral node, Object data)`

### Methods inherited from class net.sourceforge.pmd.lang.java.rule.AbstractJavaRule

`apply, getDeclaringType, importsPackage, isQualifiedName, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visit, visitAll`

### Methods inherited from class net.sourceforge.pmd.lang.rule.AbstractRule

`addExample, addRuleChainVisit, addRuleChainVisit, addViolation, addViolation, addViolation, addViolationWithMessage, addViolationWithMessage, addViolationWithMessage, deepCopyValuesTo, end, equals, getDescription, getExamples, getExternalInfoUrl, getLanguage, getMaximumLanguageVersion, getMessage, getMinimumLanguageVersion, getName, getParserOptions, getPriority, getRuleChainVisits, getRuleClass, getRuleSetName, getSince, hashCode, isDeprecated, setDeprecated, setDescription, setExternalInfoUrl, setLanguage, setMaximumLanguageVersion, setMessage, setMinimumLanguageVersion, setName, setPriority, setRuleClass, setRuleSetName, setSince, setUsesDFA, setUsesTypeResolution, start, usesDFA, usesRuleChain, usesTypeResolution`

### Methods inherited from class net.sourceforge.pmd.AbstractPropertySource

`copyPropertyDescriptors, copyPropertyValues, definePropertyDescriptor, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Methods inherited from class java.lang.Object

`clone, finalize, getClass, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface net.sourceforge.pmd.PropertySource

`definePropertyDescriptor, getPropertiesByPropertyDescriptor, getProperty, getPropertyDescriptor, getPropertyDescriptors, hasDescriptor, ignoredProperties, setProperty, useDefaultValueFor, usesDefaultValues`

### Field Detail

#### THRESHOLD_DESCRIPTOR

    public static final IntegerProperty THRESHOLD_DESCRIPTOR

#### MINIMUM_LENGTH_DESCRIPTOR

    public static final IntegerProperty MINIMUM_LENGTH_DESCRIPTOR

#### SKIP_ANNOTATIONS_DESCRIPTOR

    public static final BooleanProperty SKIP_ANNOTATIONS_DESCRIPTOR

#### EXCEPTION_LIST_DESCRIPTOR

    public static final StringProperty EXCEPTION_LIST_DESCRIPTOR

#### SEPARATOR_DESCRIPTOR

    public static final CharacterProperty SEPARATOR_DESCRIPTOR

#### EXCEPTION_FILE_DESCRIPTOR

    public static final FileProperty EXCEPTION_FILE_DESCRIPTOR

### Constructor Detail

#### AvoidDuplicateLiteralsRule

    public AvoidDuplicateLiteralsRule()

### Method Detail

#### visit

    public Object visit(ASTCompilationUnit node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `AbstractJavaRule`

#### visit

    public Object visit(ASTLiteral node,
               Object data)

Specified by:
  `visit` in interface `JavaParserVisitor`
Overrides:
  `visit` in class `AbstractJavaRule`

#### dysfunctionReason

    public String dysfunctionReason()

Description copied from interface: `PropertySource`
Returns a description of why the receiver may be dysfunctional. Usually due to missing property values or some kind of conflict between values. Returns null if the receiver is ok.

Specified by:
  `dysfunctionReason` in interface `PropertySource`
Overrides:
  `dysfunctionReason` in class `AbstractPropertySource`
Returns:
  String
See Also:
  `PropertySource#dysfunctionReason()`